with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_StructuredProxyPullConsumer_Hash is

   P : constant array (0 .. 3) of Natural :=
     (1, 4, 8, 10);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (22, 33, 35, 1);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (6, 25, 28, 27);

   G : constant array (0 .. 44) of Unsigned_8 :=
     (0, 0, 5, 0, 0, 0, 0, 0, 0, 18, 0, 10, 8, 0, 0, 0, 5, 0, 0, 19, 17, 0,
      21, 7, 0, 0, 3, 0, 3, 0, 13, 0, 15, 0, 16, 12, 10, 0, 10, 11, 8, 0, 0,
      5, 14);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 45;
         F2 := (F2 + Natural (T2 (K)) * J) mod 45;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 22;
   end Hash;

end CosNotifyChannelAdmin_StructuredProxyPullConsumer_Hash;
